## Create User Address

### cURL

```
curl --request POST \
  --url https://demo.fabric.zone/api-commerceIdentity/user/{userId}/address \
  --header 'Content-Type: application/json' \
  --header 'x-api-key: <api-key>' \
  --header 'x-site-context: <x-site-context>' \
  --data '
{
  "address1": "1234 Main St.",
  "city": "Houston",
  "state": "TX",
  "country": "USA",
  "zipCode": 77035,
  "attention": "Account Manager",
  "address2": "Suite 710",
  "address3": "Floor 7",
  "company": "Acme Inc.",
  "kind": "Business",
  "phone": {
    "number": "555-123-4567",
    "kind": "Mobile"
  },
  "name": {
    "first": "Pat",
    "last": "Kake"
  },
  "email": "test@mail.com"
}
'
```

### Python

```
import requests

url = "https://demo.fabric.zone/api-commerceIdentity/user/{userId}/address"

payload = {
    "address1": "1234 Main St.",
    "city": "Houston",
    "state": "TX",
    "country": "USA",
    "zipCode": 77035,
    "attention": "Account Manager",
    "address2": "Suite 710",
    "address3": "Floor 7",
    "company": "Acme Inc.",
    "kind": "Business",
    "phone": {
        "number": "555-123-4567",
        "kind": "Mobile"
    },
    "name": {
        "first": "Pat",
        "last": "Kake"
    },
    "email": "test@mail.com"
}
headers = {
    "x-site-context": "<x-site-context>",
    "x-api-key": "<api-key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch API)

```
const options = {
  method: 'POST',
  headers: {
    'x-site-context': '<x-site-context>',
    'x-api-key': '<api-key>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    address1: '1234 Main St.',
    city: 'Houston',
    state: 'TX',
    country: 'USA',
    zipCode: 77035,
    attention: 'Account Manager',
    address2: 'Suite 710',
    address3: 'Floor 7',
    company: 'Acme Inc.',
    kind: 'Business',
    phone: {number: '555-123-4567', kind: 'Mobile'},
    name: {first: 'Pat', last: 'Kake'},
    email: 'test@mail.com'
  })
};

fetch('https://demo.fabric.zone/api-commerceIdentity/user/{userId}/address', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://demo.fabric.zone/api-commerceIdentity/user/{userId}/address",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'address1' => '1234 Main St.',
    'city' => 'Houston',
    'state' => 'TX',
    'country' => 'USA',
    'zipCode' => 77035,
    'attention' => 'Account Manager',
    'address2' => 'Suite 710',
    'address3' => 'Floor 7',
    'company' => 'Acme Inc.',
    'kind' => 'Business',
    'phone' => [
        'number' => '555-123-4567',
        'kind' => 'Mobile'
    ],
    'name' => [
        'first' => 'Pat',
        'last' => 'Kake'
    ],
    'email' => 'test@mail.com'
  ]),
  CURLOPT_HTTPHEADER => [
    "Content-Type: application/json",
    "x-api-key: <api-key>",
    "x-site-context: <x-site-context>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>
```

### Go

```
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://demo.fabric.zone/api-commerceIdentity/user/{userId}/address"

payload := strings.NewReader("{\n  \"address1\": \"1234 Main St.\",\n  \"city\": \"Houston\",\n  \"state\": \"TX\",\n  \"country\": \"USA\",\n  \"zipCode\": 77035,\n  \"attention\": \"Account Manager\",\n  \"address2\": \"Suite 710\",\n  \"address3\": \"Floor 7\",\n  \"company\": \"Acme Inc.\",\n  \"kind\": \"Business\",\n  \"phone\": {\n    \"number\": \"555-123-4567\",\n    \"kind\": \"Mobile\"\n  },\n  \"name\": {\n    \"first\": \"Pat\",\n    \"last\": \"Kake\"\n  },\n  \"email\": \"test@mail.com\"}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-site-context", "<x-site-context>")
	req.Header.Add("x-api-key", "<api-key>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Responses

#### Success Response (200)
```json
{
  "address1": "1234 Main St.",
  "city": "Houston",
  "state": "TX",
  "country": "USA",
  "zipCode": 77035,
  "email": "test@mail.com",
  "isValidated": true,
  "isDefault": true,
  "attention": "Account Manager",
  "address2": "Suite 710",
  "address3": "Floor 7",
  "company": "Acme Inc.",
  "kind": "Business",
  "phone": {
    "number": "555-123-4567",
    "kind": "Mobile"
  },
  "name": {
    "first": "Pat",
    "last": "Kake"
  }
}
```

#### Error Response (400)
```json
{
  "error": "BAD_REQUEST",
  "code": "400",
  "message": "BAD_REQUEST"
}
```

#### Error Response (500)
```json
{
  "error": "INTERNAL_SERVER_ERROR",
  "code": "500",
  "message": "Internal server error"
}
```
